<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>Selection Sort</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <h1 id="selection-sort">Selection Sort</h1>
    <h4 id="problem-statement">Problem Statement</h4>
    <p>
      Given an unsorted array of n elements, write a function to sort the array
    </p>
    <h4 id="approach">Approach</h4>
    <ul>
      <li>select the smallest element from the array</li>
      <li>put it at the beginning of the array</li>
      <li>then select the smallest array from the remaining unsorted list</li>
      <li>append it to the sorted array at the beginning</li>
      <li>keep doing this for every element of the array</li>
      <li>repeat the above process n times</li>
    </ul>
    <h4 id="time-complexity">Time Complexity</h4>
    <p><code>O(n^2)</code> Worst case performance</p>
    <p><code>O(n^2)</code> Best-case performance</p>
    <p><code>O(n^2)</code> Average performance</p>
    <h4 id="space-complexity">Space Complexity</h4>
    <p><code>O(1)</code> Worst case</p>
    <h4 id="example">Example</h4>
    <pre><code>arr[] = {80, 10, 40, 30}
Indexes: 0   1   2   3    

1. Index = 0
    Select the minimum number from the array (between index 0-3), ie, 10
2. Swap 10  and 80 (arr[0])
3. The array now is {10, 80, 40, 30}

4. Index = 1
    Select the minimum number from the array (between index 1-3), ie, 30
5. Swap 30 and 80 (arr[1])
6. The array now is {10, 30, 40, 80}

7. Index = 2
    Select the minimum number from the array (between index 2-3), ie, 40
8. Swap 40 and 40 (arr[2])
9. The array now is {10, 30, 40, 80}

The array is now sorted.</code></pre>
    <h4 id="code-implementation-links">Code Implementation Links</h4>
    <ul>
      <li>
        <a
          href="https://github.com/TheAlgorithms/Java/blob/master/Sorts/SelectionSort.java"
          >Java</a
        >
      </li>
      <li>
        <a
          href="https://github.com/TheAlgorithms/C-Plus-Plus/blob/master/Sorting/Selection%20Sort.cpp"
          >C++</a
        >
      </li>
      <li>
        <a
          href="https://github.com/TheAlgorithms/Python/blob/master/sorts/selection_sort.py"
          >Python</a
        >
      </li>
      <li>
        <a
          href="https://github.com/TheAlgorithms/Go/blob/master/sorts/selection_sort.go"
          >Go</a
        >
      </li>
      <li>
        <a
          href="https://github.com/TheAlgorithms/Ruby/blob/master/Sorting/selection_sort.rb"
          >Ruby</a
        >
      </li>
      <li>
        <a
          href="https://github.com/TheAlgorithms/C/blob/master/sorting/SelectionSort.c"
          >C</a
        >
      </li>
      <li>
        <a
          href="https://github.com/TheAlgorithms/Scala/blob/master/src/main/scala/Sort/SelectionSort.scala"
          >Scala</a
        >
      </li>
      <li>
        <a
          href="https://github.com/TheAlgorithms/Javascript/blob/master/Sorts/selectionSort.js"
          >Javascript</a
        >
      </li>
    </ul>
    <h4 id="video-explanation">Video Explanation</h4>
    <p>
      <a href="https://www.youtube.com/watch?v=f8hXR_Hvybo"
        >A video explaining the Selection Sort Algorithm</a
      >
    </p>
    <h4 id="animation-explanation">Animation Explanation</h4>
    <ul>
      <li>
        <a href="https://boardhub.github.io/tute/?wd=selectSortAlgo2"
          >Tute Board</a
        >
      </li>
    </ul>
  </body>
</html>
